/**
*SharedFolder App
* There are different ways implementing an App
*/
var SharedFolderApp = SharedFolderApp || {};  //Define App namespace, if you want.
/**
*Constructor UNAS App
*/
SharedFolderApp.App = function () {
    this.id = 'SharedFolderApp';
    this.name = 'Shared Folder';
    this.version = '6.0.71';
    this.active = false;
    this.menuIcon = '/apps/shared-folder/images/logo.png?v=6.0.71&';
    this.shortcutIcon = '/apps/shared-folder/images/logo.png?v=6.0.71&';
	this.entryUrl = '/apps/shared-folder/shares.html?v=6.0.71&';
	//this.entryHelpUrl = '/apps/shared-folder/shared-folder_help.html?v=6.0.71&';
    var self = this;
    this.SharedFolderAppWindow = function () { //create app window
    	if(UNAS.CheckAppState('Shared Folder')){
    		return false;
    	}
    	self.window=new MUI.Window({
            id: 'SharedFolderAppWindow',
            title: UNAS._('Shared Folder'),
            icon: '/apps/shared-folder/images/logo_small.png?v=6.0.71&',
            width: 880,
            height: 500,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [200, 2000], 'y': [150, 1500] },
			loadMethod: 'xhr',
            contentURL: '/apps/shared-folder/shares.html?v=6.0.71&',
            require: {  css: ['/apps/shared-folder/css/shared-folder.css?v=6.0.71&'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Shared Folder",'SharedFolderAppWindow')}
        });
    };
	this.SharedFolderAppUninstall = function (){
    	UNAS.RemoveDesktopShortcut('Shared Folder');
    	UNAS.RemoveMenu('Shared Folder');
    	UNAS.RemoveAppFromGroups('Shared Folder', 'ControlPanel');
    	UNAS.RemoveAppFromGroups('Shared Folder', 'Help');
    	UNAS.RemoveAppFromApps('Shared Folder');
    }
    new UNAS.Menu('UNAS_ControlPanel_Storage_Menu', this.name, this.menuIcon, 'Shared Folder', '', this.SharedFolderAppWindow);
    //new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Shared Folder', this.SharedFolderAppWindow);
	new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Storage', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
	//new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Storage', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
	var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Shared Folder', UNAS._('Shared Folder')); //translate menu
        //UNAS.SetShortcutTitle('Shared Folder', UNAS._('Shared Folder')); //translate shortcut
		if (typeof self.window !== 'undefined') {
            //need to translate the window title, menu and shortcut
            UNAS.SetWindowTitle('SharedFolderAppWindow', UNAS._('Shared Folder'));
        }
    }
	UNAS.LoadTranslation('/apps/shared-folder/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
	UNAS.CreateApp(this.name,this.shortcutIcon,this.SharedFolderAppWindow,this.SharedFolderAppUninstall);
};
new SharedFolderApp.App(); //Create app
