var editaclWin = window.top.UNAS.GetWindow('jv-editshearedfolderaclWindow');
var acl_widData = editaclWin.options;
var acl_currentTarget = acl_widData.target;

var group_map = sddl_info.map.group;
var user_map = sddl_info.map.user;
var groups = sddl_info.group;
var users = sddl_info.user;
var isDir = true;
var new_ace = false;
var check_acl = false;

function usersid2name(sid) {
  username = sid
  if (typeof(user_map[sid]) !== "undefined") {
    username = user_map[sid]
  } else if (typeof(users[sid]) != "undefined") {
    username = users[sid]
  }
  return username;
}

function groupsid2name(sid) {
  groupname = sid;
  if (typeof(group_map[sid]) !== "undefined") {
    groupname = group_map[sid]
  } else if (typeof(groups[sid]) != "undefined") {
    groupname = groups[sid]
  }
  return groupname;
}

function set_acl_line(ace) {
  var sid, name, type, perm, flags, sddltype, preponderance
  perm = {
    'value': '0x00100000'
  }
  ace.details.forEach((item, i) => {
    switch (item.title) {
      case "Type":
        type = item.value;
        break
      case "Flags":
        flags = item.value;
        break
      case "Rights":
        perm = item;
        if (perm.value.indexOf('0x') == -1) {
          perm_hex = 0
          // Alphabet described rights
          for (var i = 0; i < perm.value.length / 2; i++) {
            sd = perm.value.substr(i * 2, 2)
            if (typeof(SddlAceRights2int[sd]) != 'undefined') {
              perm_hex = perm_hex | SddlAceRights2int[sd]
            }
          }
          perm.value = '0x00' + perm_hex.toString(16)
        }
        break
      case "AccountSid":
        sid = item.value;
        name = item.details;
        preponderance = item.details;
        break
    }
  })

  var nasuser = sddl_info.nas.user || [];
  var nasgroup = sddl_info.nas.group || [];

  if (nasuser.includes(usersid2name(sid)) || user_map.hasOwnProperty(sid)) {
    sddltype = 'unasuser';
  }else if (users.hasOwnProperty(sid)) {
    sddltype = 'sysuser';
  }

  if (nasgroup.includes(groupsid2name(sid)) || group_map.hasOwnProperty(sid)) {
    sddltype = 'unasusergroup';
  }else if (groups.hasOwnProperty(sid)) {
    sddltype = 'sysusergroup';
  }

  if (SddlSids.hasOwnProperty(sid)) {
    sddltype = 'sysusergroup';
  }

  var txt = {
    unasuser: 'User',
    unasusergroup: 'User Group',
    sysuser: 'System User',
    sysusergroup: 'System User Group'
  }

  inherited = false;
  if (typeof(flags) == "string" && flags.includes("ID")) {
    inherited = true
  }
  line = '<tr class="trp ' + (inherited ? 'acldisabledbtn' : '') + '" type="' + sddltype + '" inherited="' + inherited + '" perm="' + perm.value + '" ace="' + ace.value + '" onmouseover="jQuery(this).addClass(\'on\')" onmouseout="jQuery(this).removeClass(\'on\')">'

  if (sid !== preponderance) {

  } else {
    preponderance = groupsid2name(sid);
    if (preponderance !== sid) {} else {
      preponderance = usersid2name(sid)
    }
  }

  line += '<td width="20%" align="left" class="u-file_acl_username" sid="' + sid + '" username="' + preponderance + '"><span class="unas_table_text">' + preponderance + '</span></td>'
  if (sid !== name) {
    // Inner object. Regard as group
    line += '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(txt[sddltype]) + '</span></td>'
  } else {
    // Try as group
    name = groupsid2name(sid);
    if (name !== sid) {
      line += '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(txt[sddltype]) + '</span></td>'
    } else {
      // Else all regard as user
      name = groupsid2name(sid);
      line += '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(txt[sddltype]) + '</span></td>'
    }
  }

  switch (type) {
    case "A":
      line += '<td width="10%" align="left" class="u-file_acl_type" code="A"><span class="unas_table_text">' + UNAS._('Allow') + '</span></td>'
      break;
    case "D":
      line += '<td width="10%" align="left" class="u-file_acl_type" code="D"><span class="unas_table_text">' + UNAS._('Deny') + '</span></td>'
      break;
    default:
      line += '<td width="10%" align="left" class="u-file_acl_type" code="' + type + '"><span class="unas_table_text">' + type + '</span></td>'
  }

  if (typeof(SddlWinPermission[perm.value]) !== 'undefined') {
    line += '<td width="20%" align="left"><span class="unas_table_text">' + UNAS._(SddlWinPermission[perm.value]) + (inherited ? '(' + UNAS._('INHERIT') + ')' : '') + '</span></td>'
  } else {
    line += '<td width="20%" align="left"><span class="unas_table_text">' + UNAS._('Customized') + (inherited ? '(' + UNAS._('INHERIT') + ')' : '') + '</span></td>'
  }
  if (isDir) {
    if (flags) {
      line += '<td width="25%" align="left" class="u-file_acl_flags" flags="' + flags + '"><span class="unas_table_text">' + UNAS._(SddlWindowsApplyTo[flags]) + '</span></td>'
    } else {
      line += '<td width="25%" align="left" class="u-file_acl_flags" flags=""><span class="unas_table_text">' + UNAS._(SddlWindowsApplyTo['0']) + '</span></td>'
    }
  }

  if (inherited) {
    line += '<td width="15%" align="left"><span class="unas_table_text">' +
      '<a class="editfile acldisabledbtn"></a><a class="deletefile acldisabledbtn"></a>' +
      '</span></td>'
  } else {
    line += '<td width="15%" align="left"><span class="unas_table_text">' +
      '<a class="editfile" onclick="aceEdit(this)" ></a>' +
      '<a class="deletefile" onclick="btnDeleteAcl(this)"></a>' +
      '</span></td>'
  }

  line += '</tr>';
  return line
}

function sddldetails() {
  var sddl = sddlParseAny(sddl_info.sddl);
  sddl.details.forEach((header_item, num) => {
    switch (header_item.value) {
      case 'O':
        // owner
        sid = header_item.details.value;
        username = usersid2name(sid);
        if (username == sid) {
          // Failed to find mapped user, add it into list
          jQuery("#u-file_explorer_acl_owner").append('<li value="' + sid + '">' + username + "&nbsp;</li>");
        }
        jQuery("#jv-acl_owner_val").text(username).attr('value', sid);
        break;
      case 'G':
        // group
        sid = header_item.details.value;
        groupname = groupsid2name(sid);
        if (groupname == sid) {
          // Failed to find mapped group, add it into list
          jQuery("#u-file_explorer_acl_group").append('<li value="' + sid + '">' + groupname + "&nbsp;</li>");
        }
        jQuery("#jv-acl_group_val").text(groupname).attr('value', sid);
        break
      case 'D':
        // DACL
        // Detailed ACL info
        var flags = '';
        var aces;
        header_item.details.details.forEach((item, i) => {
          switch (item.title) {
            case "Flags":
              flags = item.value;
              SE_DACL_PROTECTED = false;
              SE_DACL_AUTO_INHERITED = false;
              item.details.forEach((dacl_flag, j) => {
                if (dacl_flag["value"] == "AI") {
                  SE_DACL_AUTO_INHERITED = true;
                } else
                if (dacl_flag["value"] == "P") {
                  SE_DACL_PROTECTED = true;
                }
              })
              if (SE_DACL_AUTO_INHERITED && !SE_DACL_PROTECTED) {
                jQuery('#u-file_explorer_inherit')[0].checked = true;
              }
              break
            case "ACEs":
              aces = item.details;
              break;
          }
        })
        jQuery("#u-file_explorer_sddl").attr("flags", flags);
        aces.forEach((ace, a) => {
          jQuery('#u-file_explorer_acl_list').append(set_acl_line(ace));
        })
        break;
      case 'S':
        // Should not happen in samba
        break;
      default:
        // No way
    }
  })
}

function aceEdit(t) {
  new_ace = false;
  check_acl = false;
  customPrivilegeWindowFun(t);
}

function addace() {
  new_ace = true;
  check_acl = false;
  customPrivilegeWindowFun();
}

function checkACL() {
  check_acl = true;
  customPrivilegeWindowFun();
}

function editSharedFoldersddl() {
  var new_sddl = 'O:' + jQuery('#jv-acl_owner_val').attr('value');
  new_sddl += 'G:' + jQuery('#jv-acl_group_val').attr('value');
  new_sddl += 'D:';
  var inherit = jQuery('#u-file_explorer_inherit')[0].checked;
  if (inherit) {
    new_sddl += "AI";
  } else {
    new_sddl += "PAI";
  }
  jQuery('#u-file_explorer_acl_list tr').each(function(i, e) {
    ace = jQuery(e).attr("ace");
    inherited = false;
    jQuery.isArray(sddlParseACE(ace).details[1].details) &&
      sddlParseACE(ace).details[1].details.forEach((inherit_flag, j) => {
        if (inherit_flag["value"] == "ID") {
          inherited = true;
        }
      })
    if (!inherited || inherit) {
      new_sddl += ace;
    }
  })
  edit_sddl = new_sddl;
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;

  if (create_acl) {
    getPermissionuserlist(new_sddl);
    MUI.closeWindow($('jv-editshearedfolderaclWindow'));
    return;
  }

  data = {
    cmd: "acl_setsddl",
    token: UToken,
    params: {
      sddl: new_sddl,
      path: create_acl ? '/' : path,
      chown: 0,
      lazy : 1,
      force_cover: 0
    }
  }
  jQuery.ajax({
    url: "/api/acl/index.php",
    type: "POST",
    async: true,
    timeout: 20000,
    dataType: "json",
    contentType: "json",
    data: JSON.encode(data),
    success: function(data) {
      var errmsg = {
        9988: 'Permission denied',
        9994: 'Not exists',
        9895: 'Partly succeed. Failed to set some child items.',
        9999: 'Failed to set ACL'
      }

      if (data.err == 0) {
        MUI.closeWindow($('jv-editshearedfolderaclWindow'));
        var p_node = jQuery(acl_currentTarget).parents('.unas_table');
        var p_td = jQuery(acl_currentTarget).parents('td').siblings();
        var p_th = p_node.find('.unas_table_title th');
        p_th.each(function(i, e) {
          jQuery(e).find('input[type=checkbox]').prop('checked', false);
        })
        p_td.each(function(i, e) {
          jQuery(e).find('input[type=checkbox]').prop('checked', false);
        })

        jQuery(acl_currentTarget).prop('checked', true);

        getPermission();

      } else {
        alert(errmsg[data.err]);
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function btnDeleteAcl(t) {
  var p_node = jQuery(t).closest('tr.trp');
  p_node.remove();
};

function acluesrCheckbox(e) {
  var event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  jQuery('#u-file_explorer_acl_list tr').hide();
  var acl_list = jQuery('#u-file_explorer_acl_list tr');
  var len = jQuery('#jv-showaclusertypebox input[type=checkbox]:checked').length;
  if (len == 0) {
    e.checked = true;
  }
  jQuery('#jv-showaclusertypebox input[type=checkbox]:checked').each(function(i, e) {
    acl_list.each(function(i, ac) {
      var inherited = jQuery(ac).attr('inherited');
      if (inherited == 'false') {
        if (jQuery(ac).attr('type') == e.value) {
          jQuery(ac).show();
        }
      } else {
        if (e.value == 'inherited') {
          jQuery(ac).show();
        }
      }

    })
  })
}
